local skills = {}

-- attack

local tackpic = string.match(text, "<input type=hidden name=action value=\"attack\">.-<input id='tack' picurl=([a-z0-9_]+) ")
if tackpic then
	skills["Attack"] = {
		["name"] = "Attack",
		["basename"] = "Attack",
		["picture"] = tackpic,
		["type"] = "attack",
	}
end

-- run away

if string.match(text, "<input type=hidden name=action value=\"steal\">") then
	skills["Pick Pocket"] = {
		["name"] = "Pick Pocket",
		["basename"] = "Pick Pocket",
		["picture"] = "knobsack",
		["type"] = "steal",
	}
end

-- jiggle chefstaff

local jiggpic = string.match(text, "<input type=hidden name=action value=\"chefstaff\">.-<input id='chefstaffbutton' picurl=([a-z0-9_]+) ")
if jiggpic then
	skills["Jiggle Chefstaff"] = {
		["name"] = "Jiggle Chefstaff",
		["basename"] = "Jiggle Chefstaff",
		["picture"] = jiggpic,
		["type"] = "chefstaff",
	}
end

-- skills

local skilltext = string.match(text, "<select name=whichskill>(.-)</select>") or ""
for id, pic, name, cost in string.gmatch(skilltext, "<option value=\"([0-9]-)\" picurl=\"([a-z0-9]-)\" .->(.-) %(([0-9]-) M[a-z]- Points?%)</option>") do
	skills[name] = {
		["name"] = name,
		["basename"] = name,
		["picture"] = pic,
		["type"] = "spell",
		["cost"] = cost,
		["spellid"] = id,
	}
end

-- items

local itemtext = string.match(text, "<select name=whichitem>(.-)</select>") or ""
itemtext = string.gsub(itemtext, "(<option picurl=[a-z0-9]-) selected (value=[0-9]->)", "%1 %2")
for pic, id, name, amount in string.gmatch(itemtext, "<option picurl=([a-z0-9]-) value=([0-9]-)>(.-) %(([0-9]-)%)</option>") do
	skills[name] = {
		["name"] = name,
		["basename"] = name,
		["picture"] = pic,
		["type"] = "item",
		["amount"] = amount,
		["itemid"] = id,
	}
end

function set_custom_combat_skill(name, basename)
-- 	print("setting " .. tostring(name) .. " to " .. tostring(basename))
	if skills[basename] then
		table.insert(custom_combat_skills, name)
		skills[name] = {
			["name"] = name,
			["basename"] = skills[basename]["basename"],
			["picture"] = skills[basename]["picture"],
			["type"] = skills[basename]["type"],
			["spellid"] = skills[basename]["spellid"],
			["itemid"] = skills[basename]["itemid"],
			["cost"] = skills[basename]["cost"],
			["amount"] = skills[basename]["amount"],
		}
	else
		print("Custom combat skill error! Baseskill doesn't exist!", name, "->", basename)
	end
end

-- scripted custom skills

local toset = {}
for a, b in pairs(combat_skill_functions) do
	x = b.f(skills)
	if x then
		table.insert(toset, { name = b.name, skill = x })
	end
end
for a,b in pairs(toset) do set_custom_combat_skill(b.name, b.skill) end

-- simple user-specified custom skills

local resolve_list = {}
for a, b in pairs(simple_combat_skills) do
	resolve_list[b.name] = b.list
end

local entered = {}
local function process_skill(name)
	for x, description in pairs(resolve_list[name]) do
		local passed_filters = true

		local filters = {}

		filters["r"] = (function (test)
			test = string.gsub(test, " ", "")
			local roundmin, roundmax = string.match(test, "^([0-9]+)%-(([0-9]+))$")
			if not roundmin then
				roundmin = string.match(test, "^([0-9]+)%+$")
				roundmax = "1000"
			end
			if not roundmin then
				roundmin = string.match(test, "^([0-9]+)$")
				roundmax = roundmin
			end
			if combat_round then
-- 				print("testing round", round, roundmin, roundmax)
				if combat_round < tonumber(roundmin) or combat_round > tonumber(roundmax) then
					return false
				end
			else
				return false
			end
		end)

		filters["z"] = (function (test)
			local z = tonumber(string.match(test, "^([0-9]+)$"))
-- 			print("testing zone", zone, z)
			if adventure_zone ~= z then
				return false
			end
		end)

		filters["m"] = (function (test)
			if monster_name == test then
				return true
			else
				return false
			end
		end)

		for code, rawtest in string.gmatch(description, "([a-z]) *(%b{})") do
			if filters[code] then
				local test = string.gsub(rawtest, "^{ *(.-) *}$", "%1")
-- 				print(code,test,"=>",filters[code](test))
				if filters[code](test) == false then
					passed_filters = false
				end
			else
				passed_filters = false
			end
		end

		if passed_filters then
			local skillname = string.gsub(description, "[a-z] *%b{} *", "")
-- 			print("skill",name,description,skillname)
			if resolve_list[skillname] and not entered[skillname] then
				entered[skillname] = true
				local s = process_skill(skillname)
				if s then return s end
			end
			if skills[skillname] then
				return skillname
			end
		end
	end
end

local toset = {}
for a, b in pairs(simple_combat_skills) do
	entered = {}
	s = process_skill(b.name)
	if s then
		table.insert(toset, { name = b.name, skill = s })
	end
end
for a,b in pairs(toset) do set_custom_combat_skill(b.name, b.skill) end



-- do it

-- posting page /fight.php params: Just [("action","useitem"),("whichitem","2176"),("whichitem2","2174")]

if not active then
	local combat_skill_state_table = {}
	for a,b in pairs(custom_combat_skills) do
		data = skills[b]
		if data["type"] == "spell" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], action = "skill", whichskill = data["spellid"] }
		elseif data["type"] == "item" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], action = "useitem", whichitem = data["itemid"] }
		elseif data["type"] == "attack" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], action = "attack" }
		elseif data["type"] == "steal" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], action = "steal" }
		elseif data["type"] == "chefstaff" then
			combat_skill_state_table[data["name"]] = { basename = data["basename"], action = "chefstaff" }
		end
	end
-- 	print("setting combat skills fightstate: " .. table_to_str(combat_skill_state_table))
	set_fight_state("combat skills", table_to_str(combat_skill_state_table))
end

if active then
	for a,b in pairs(custom_combat_skills) do
		data = skills[b]
		text = string.gsub(text, "(<select name=whichskill>.-)(</select>)", "%1<option value=\""..("custom skill "..data["name"]).."\" picurl=\""..data["picture"].."\" >"..data["name"].." ("..(data["cost"] or 0).." Mana Points)</option>%2")
	end
end

return text
